<?php

namespace App\Http\Requests;


use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class AuctionRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = ['super_admin', 'admin'];
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('products'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[
            
                'user_id'=>'required',
                'category_id'=>'required',
                'main_model_id'=>'required',
                'start_cost'=>'required',
                'end_cost'=>'required',
                'start_time'=>'required',
                'end_time'=>'required',
               
                'latlng'=>'required',
                'address'=>'required',
                'country_id'=>'required',
                'city_id'=>'required',
                'image'=>'required',
                'video'=>'required',
                'image'=>'required',
                

        ];

         foreach (languages() as $lang) {
            $lang_rules=[
                'name_'.$lang->local=> 'required',

                'description_'.$lang->local=> 'required',
                


            ];
            $rules= array_merge($rules, $lang_rules);
        }
       

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $element = request('element');
       
        $attributes= [
            'category_id'=>  __('products.category_id'),
            'sell_id'=>__('products.user'),
            'main_model_id'=>__('products.main_model'),
            'model_id'=>__('products.model'),
            'cost'=>__('products.cost'),
            'image'=>__('products.image'),
            
        ];
         foreach (languages() as $lang) {
            $lang_attributes=[
                'name_'.$lang->local => $service->{'name_'.$lang->local} ?? __('products.name'),
                'description_'.$lang->local => $service->{'description_'.$lang->local} ?? __('products.description'),
            ];
            $attributes= array_merge($attributes, $lang_attributes);
}
if(isset($element))
{
 foreach ($element as $key => $row) {
    $serial = ($key + 1);
          if (empty($value['element'])){
                $element = ['element.'.$key.'.element' => "Element $serial Element"];
                $attributes = array_merge($attributes, $element);
            }
             if (empty($value['count'])){
                $count = ['element.'.$key.'.count' => "Element $serial Count"];
                $attributes = array_merge($attributes, $count);
            }
          }
}
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
